/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: AttachmentSupport.java,v 1.3 2006/07/23 21:43:25 cara Exp $ */

package org.openoces.opensign.appletsupport;

/**
 * This interface defines attachment specific methods 
 *
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;

import java.applet.Applet;
import java.awt.*;

public interface AttachmentSupport extends AppletSupport {
    public void init(RestrictedAction ra, Applet applet, String attachmentParam);
    public void show(RestrictedAction ra, Frame parent);
    public Attachment [] getAttachments();

    /**
     * Returns if it is ok to sign in the current state, ie. if check if all mandatory attachments have been
     * viewed or saved locally.
     *
      * @return whether it is ok to sign in the current state with respect to the attachments
     */

    public boolean isSigningOK();
}
