/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: AbstractCertificateHandler.java,v 1.8 2006/04/02 08:52:35 cara Exp $ */

package org.openoces.opensign.certificate;

import java.util.Properties;

/**
 * This class represents a generic interface to a certificate
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 */
public interface AbstractCertificateHandler extends CertificateInfo {

    public byte[] sign(byte[] toBeSigned, char[] password) throws Exception;

    public byte[] digest(byte[] toBeHashed) throws Exception;

    /**
     * Return the der encoded certificate
     *
     * @return byte[]
     */
    public byte[] getCertificate() throws Exception;

    /**
     * Return the known chain of der encoded certificates. The user certificate is at index 0
     *
     * @return byte[]
     */
    public byte[][] getCertificateChain(char[] password) throws Exception;

    public String getStoreName();

    // if you want to pass extra info about a certificate (like path to cd-card...)
    public Properties getExtraCertificateProperties();
}
