/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: CertificateList.java,v 1.8 2006/08/12 19:02:36 cara Exp $ */

package org.openoces.opensign.certificate;

import java.io.File;

import org.openoces.opensign.certificate.filter.CertificateFilter;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

/**
 * This class represents a list of certificates
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 * @author Preben Valeur  <prv@tdc.dk>
 * @author Carsten Raskgaard  <carsten@raskgaard.dk>
 */
public class CertificateList {
    private AbstractCertificateHandler[] certificates;

    public CertificateList() {
        this.certificates = new AbstractCertificateHandler[0];
    }

    public AbstractCertificateHandler[] getUsableCertificates() {
        return certificates;
    }

    private void addCertificate(AbstractCertificateHandler certificateHandler) {
        try {
            if (!CertificateFilter.acceptByAll(certificateHandler)){
                return;
            }
        } catch (Exception e){
            FileLog.error("exception when adding: "+e.getMessage());
            return;
        }
        AbstractCertificateHandler certificateList[] = new AbstractCertificateHandler[certificates.length + 1];
        for ( int i=0; i<certificates.length; i++ ) {
            certificateList[i] = certificates[i];
        }
            certificateList[certificates.length] = certificateHandler;
            certificates = certificateList;
    }

    public void addCertificateFromFile(File f, char[] password) throws Exception {
        FileLog.error(">>>>>>>>>>>>>> addCertificateFromFile not used anymore!!!");
//        addCertificate(new Pkcs12CertificateHandler(f, password));
    }

    public void addCertificatesFromMicrosoftWindowsKeyStore() {
        FileLog.error(">>>>>>>>>>>>>> addCertificatesFromMicrosoftWindowsKeyStore not used anymore!!!");
//        AbstractCertificateHandler newCerts[] = MicrosoftWindowsCertificateCache.getInstance().getCertificates();
//        if (certificates != null){
//            AbstractCertificateHandler certificateList[] = new AbstractCertificateHandler[certificates.length + newCerts.length];
//            System.arraycopy(certificates, 0, certificateList, 0, certificates.length);
//            System.arraycopy(newCerts, 0, certificateList, certificates.length, newCerts.length);
//            certificates = certificateList;
//        } else {
//            certificates = newCerts;
//        }
    }
}
