/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: CopyableCdCardCertificateHandler.java,v 1.5 2006/08/12 19:02:34 cara Exp $ */

package org.openoces.opensign.certificate.plugin.cdcard;

/**
 * This class represents an cdcard that can be copied
 *
 * @author Preben Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.FileLog;
import org.openoces.opensign.certificate.CopyableItem;

import java.awt.*;
import java.io.File;

public class CopyableCdCardCertificateHandler extends CdCardCertificateHandler implements CopyableItem {
    protected CopyableCdCardCertificateHandler(CdCardKeyStoreHandler handler, String dirPath) throws Exception {
        super(handler, dirPath);
    }

    // copy the item from the default place to a user selected place
    public void backup(Frame parent) {
        //To change body of implemented methods use File | Settings | File Templates.
        // todo: implement
        FileLog.debug("backup called");
        handler.getCallBackHandler().confirmedUserMessage("info", "NYI: Certifikatet bliver kopieret til et sted du kan v�lge");
    }

    // delete from the default place
    public void delete(Frame parent) {
        //To change body of implemented methods use File | Settings | File Templates.
        FileLog.debug("delete called");
        handler.getCallBackHandler().confirmedUserMessage("info", "Certifikatet bliver slette fra "+filePath);
        // delete the files ... and myself...
        File certFile = new File(filePath);
        if (!handler.getRestrictedAction().delete(certFile)){
            FileLog.debug("Error deleting file "+certFile.getAbsolutePath());
        }
        handler.forgetScan();
    }
}
