/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: MsCryptoSupport.java,v 1.5 2006/08/12 19:02:35 cara Exp $ */

package org.openoces.opensign.certificate.support.mscrypto;

import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.provider.JDKDigestSignature;
import org.openoces.opensign.certificate.support.suncrypto.SunCryptoSupport;
import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.crypto.SSLResponse;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.security.Provider;
import java.security.Signature;
import java.util.Enumeration;
import java.util.Hashtable;

/**
 * This class represents the interface to high-level crypto functionality on the Microsoft platform
 *
 * @author Preben Valeur  <prv@tdc.dk>
 */

public class MsCryptoSupport extends SunCryptoSupport {
    public MsCryptoSupport(){
        FileLog.debug("NOT Adding BouncyCastleProvider");
        Provider p = new BouncyCastleProvider();
//        OS.getRestrictedAction().addSecurityProvider(new BouncyCastleProvider());
    }

    protected Signature getSignature(){
        return new JDKDigestSignature.SHA1WithRSAEncryption();
    }
    public SSLResponse httpsPost(URL url, Hashtable params, RestrictedAction ra) {
        return MsCryptoSupport.browserHttpsPost(url, params, ra);
    }

    public byte[] sha1(byte[] bytes) throws Exception {
//        put("MessageDigest.SHA-1", "org.bouncycastle.jce.provider.JDKMessageDigest$SHA1");
//        MessageDigest sha = MessageDigest.getInstance("SHA1");
        // todo: make more JCE-like!
        MessageDigest sha = new org.bouncycastle.jce.provider.JDKMessageDigest.SHA1();
        return sha.digest(bytes);
//        return JCETools.sha1(bytes);
    }


    public static SSLResponse browserHttpsPost(URL url, Hashtable params, RestrictedAction ra) {
        StringBuffer lines = new StringBuffer();
        try {
            // Construct data
            StringBuffer data = new StringBuffer();
            boolean first = true;
            for (Enumeration keys = params.keys(); keys.hasMoreElements();) {
                if (!first) data.append("&");
                String key = (String) keys.nextElement();
                String value = (String) params.get(key);
                data.append(URLEncoder.encode(key));
//                data.append(URLEncoder.encode(key, "UTF-8")); // since 1.4...
                data.append("=");
                data.append(URLEncoder.encode(value));
                first = false;
            }
            // Send data
//            URL url = new URL(AKS_SERVER);
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            ra.connect(conn);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            wr.write(data.toString());
            wr.flush();

            // Get the response
            BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = rd.readLine()) != null) {
                // Process line...
                lines.append(line);
                lines.append('\n');
//                System.out.println("line: "+line);
            }
            wr.close();
            rd.close();
        } catch (Exception e) {
            FileLog.error("Exception posting: "+e.toString());
            return null;
//            return new SSLResponse(new StringBuffer(e.toString()));//todo: throw exception?
        }
        return new SSLResponse(lines);
    }

}
