/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: CallBackHandler.java,v 1.4 2006/04/05 20:03:42 cara Exp $ */

package org.openoces.opensign.client.applet;

/**
 * This interface specifies a callback interface
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 */

import org.openoces.opensign.exceptions.UserCancel;

import java.applet.Applet;
import java.awt.*;


public interface CallBackHandler {
    public void alert(String message);

    public void userMessage(String header, String message, boolean error);

    public void clearUserMessage(boolean error);

    public void confirmedUserMessage(String header, String message);

    public String promptPassword(String message) throws UserCancel;

    public Applet getApplet();

    public Frame getFrame();
}
