/*
<<<<<<< Logon.java
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: Logon.java,v 1.16 2006/10/15 10:28:55 cara Exp $ */

package org.openoces.opensign.client.applet;

/**
 * This class implements the Logon applet
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 * @author Carsten Raskgaard  <carsten@raskgaard.dk>
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.certificate.AbstractCertificateHandler;
import org.openoces.opensign.client.applet.resources.ResourceManager;
import org.openoces.opensign.exceptions.InputDataError;
import org.openoces.opensign.exceptions.UserCancel;
import org.openoces.opensign.client.applet.bootstrap.FileLog;
import org.openoces.opensign.utils.GridLayout2;
import org.openoces.opensign.utils.Version;
import org.openoces.opensign.xml.xmldsig.SignatureGenerator;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.Properties;

public class Logon extends AppletLayout {

    public Logon() {
        super();
        FileLog.debug("xxx Logon <cons>) " + this.getClass().getClassLoader());
        this.setName(ResourceManager.getString("TITLE_LOGON") + " v." + Version.getBuildVersion());
    }

    public String getAppletInfo() {
        return "OpenLogon";
    }

    protected Button getOkButton() {
        bOk.setLabel(ResourceManager.getString("OK_LOGON_MODERN"));
        return bOk;
    }

    protected Button getCancelButton() {
        bCancel.setLabel(ResourceManager.getString("CANCEL_LOGON_MODERN"));
        return bCancel;
    }

    protected Panel getHeaderPanel() {
        // Construct text like:
        // "Log ind p� Virk.dk ved at v�lge din digitale signatur og klik OK."
        // LOGONTO + host + BYDOINGANDCLICKING + OK_BTN_LABEL
        // todo: make it so
        Panel p = new Panel(new FlowLayout(FlowLayout.LEFT, 0, 0));
        String host = lHost.getText();
        URL hostUrl = null;
        try {
            hostUrl = new URL(lHost.getText());
            host = hostUrl.getHost();
        } catch (MalformedURLException e) {
            // stick with the old text
        }
        // "V�lg digital signatur og log ind p� <host-navnet som appletten loades fra>"
        String header = ResourceManager.getString("LOGON_HOW_TO2") + " " + host;
        p.add(new Label(header));
        return p;
    }

    protected Button getFunctionsButton() {
        bFunctions.setLabel(ResourceManager.getString("FUNCTIONS_MODERN_LOGON"));
        return bFunctions;
    }

    protected Panel getCertListPanel(int space) {
        Panel certListPanel = new Panel(new FlowLayout(FlowLayout.LEFT, 0, 0));

        certListPanel.add(chCertList);

        // could add details button:
        // todo: finish this:
        if (getExternalCertificateEnabledIndicator()) {
            certListPanel.add(new SpacerComponent(space));//spacer
            certListPanel.add(getFunctionsButton());
        }
        return certListPanel;
    }

    private static class SpacerComponent extends Canvas {
        private int w;

        SpacerComponent(int w) {
            this.w = w;
        }

        public Dimension getMinimumSize() {
            Dimension d = super.getMinimumSize();
            d.width = w;
            return d;
        }

        public Dimension getPreferredSize() {
            Dimension d = super.getPreferredSize();
            d.width = w;
            return d;
        }
    }

    private Panel getButtonPanel2(int space) {
        Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.LEFT, 0, 4));
        if (getCancelButtonEnabledIndicator()) {
            buttonPanel.add(getCancelButton());
            buttonPanel.add(new SpacerComponent(space));//spacer
        }
        buttonPanel.add(getOkButton());
        return buttonPanel;
    }

    private Panel getMessagePanel() {
        Panel buttonPanel = new Panel(new BorderLayout());
        userMessageLabel = new Label();
        userMessageLabel.setForeground(Color.red);
        buttonPanel.add(userMessageLabel, BorderLayout.CENTER);
        return buttonPanel;
    }
    // end new layout

    private void doClassicLayout() throws InputDataError {
        setLayout(new GridBagLayout());
        GridBagConstraints c = getGridBagConstraints();

        add(lLogonTo, c);
        c.gridx++;
        c.gridwidth = 3;
        add(lHost, c);
        c.gridy++;

        c.gridwidth = 1;
        c.gridheight = 1;

        c.gridx = 0;
        add(lCertList, c);
        c.gridx++;
        add(chCertList, c);

        if (tfSocialSecurityNumber != null) {
            c.gridx = 0;
            c.gridy++;
            add(lSocialSecurityNumber, c);
            c.gridx++;
            add(tfSocialSecurityNumber, c);
        }
        if (tfOptionalEntry != null) {
            c.gridx = 0;
            c.gridy++;
            add(lOptionalEntry, c);
            c.gridx++;
            add(tfOptionalEntry, c);
        }
        c.gridx = 0;
        c.gridy++;
        add(lPassword, c);
        c.gridx++;
        add(tfPassword, c);

        c.gridy = 0;
        c.gridx++;
        //		add(browseButton, c);
        c.gridx = 0;
        c.gridy++;
        c.gridx++;
        //		add(disketteButton, c);

        c.gridx = 0;
        c.gridy = 4;

        c.gridwidth = 3;

        Panel pnl = new Panel();
        pnl.add(bOk);
        pnl.add(bCancel);
        pnl.add(bFunctions);

        add(pnl, c);
    }

    protected void doModernLayout() {
        Panel northPanel = new Panel();
        northPanel.setLayout(new GridLayout2(0, 1, 0, 0));
        int space = 5;
        northPanel.add(getHeaderPanel());
        northPanel.add(getCertListPanel(space));
        northPanel.add(getButtonPanel2(space));
        northPanel.add(getMessagePanel());

        setLayout(new BorderLayout());
        add(northPanel, BorderLayout.NORTH);
        add(new Panel(), BorderLayout.CENTER);//space
    }

    protected ParamReader createParamReader() {
        // find out if we have xml input in "signtext" and set paramreader if so

        String explicitInputStyle = getParameter("inputstyle");
        String virkLogon = getParameter("VIRK_LOGON");

        if (explicitInputStyle != null) {
            if ("default".equals(explicitInputStyle)) {
                return new DefaultParamReader(this);
            } else if ("virk".equals(explicitInputStyle)) {
                return new AppletArguments(this);
            } else {
                return new DefaultParamReader(this);
            }
        } else {
            if (virkLogon != null) {
                return new AppletArguments(this);// could be named XmlParamReader..
            } else {
                return new DefaultParamReader(this);
            }
        }
    }

    public void initialize() throws Exception {
        if (classicStyle()) {
            FileLog.debug("initialize Logon to classic style");
            doClassicLayout();
        } else {
            FileLog.debug("initialize Logon to modern style");
            doModernLayout();
        }

        ActionListener okAction = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                enableDialog(false);
                FileLog.info("Timing: Ok pushed in Logon: " + new Date());
                char[] password = tfPassword.getText().trim().toCharArray();
                clearPassword();
                AbstractCertificateHandler currentCertificate = getSelectedCertificate();
                if (currentCertificate != null) {
                    try {
                        FileLog.debug("ok pressed, selected cert:" + currentCertificate.getUserfriendlyName());
                        Properties invisibleProps = getSignProperties();
                        addLayoutSettings(invisibleProps);
                        addCertificateProperties(invisibleProps, currentCertificate);
                        String socialSecurityNumber = null;
                        String optionalEntry = null;

                        if (tfSocialSecurityNumber != null) {
                            socialSecurityNumber = tfSocialSecurityNumber.getText().trim();
                            if (socialSecurityNumber.equals(""))
                                socialSecurityNumber = null;
                        }
                        if (tfOptionalEntry != null) {
                            optionalEntry = tfOptionalEntry.getText().trim();
                            if (optionalEntry.equals("")) {
                                optionalEntry = null;
                            }
                        }

                        String signtext = "OpenLogon " + SimpleDateFormat.getInstance().format(new Date(System.currentTimeMillis()));
                        String hostName = lHost.getText().trim();
                        FileLog.info("Timing: before generating signature: " + new Date());

//                        signerThread = ra.createThread(new SignerThread(currentCertificate, password, socialSecurityNumber, optionalEntry, signtext, hostName, p));
//                        signerThread.run();

                        invisibleProps.put(SignatureGenerator.SIGNTEXT, signtext);
                        Properties visibleProps = new Properties();
                        if (socialSecurityNumber != null) {
                            visibleProps.put(SignatureGenerator.SOCIALSECURITYNUMBER, socialSecurityNumber);
                        }
                        if (optionalEntry != null) {
                            visibleProps.put(SignatureGenerator.OPTIONALFIELD2, optionalEntry);
                        }
                        if (hostName != null) {
                            visibleProps.put(SignatureGenerator.HOSTNAME, hostName);
                        }
                        SignatureGenerator sigGen = paramReader.createSignatureGenerator();
                        StringBuffer signature = sigGen.logon(currentCertificate, password, visibleProps, invisibleProps);
                        handleOk("onLogonOK", signature);
                    } catch (InputDataError ex) {
                        // Tell the user but let the user try again
                        userMessage("", ex.getMessage(), true);
                    } catch (UserCancel ex) {
                        // Tell the user but let the user try again
                        userMessage("", ex.getMessage(), true);
                    } catch (IOException ex) {
                        FileLog.error("could not create logon signature, wrong password");
                        handleError("onLogonError", "wrong password");
                    } catch (Exception ex) {
                        FileLog.error("could not create logon signature", ex);
                        handleError("onLogonError", ex.toString());
                    }
                }
                enableDialog(true);
            }
        };
        bOk.addActionListener(okAction);
        tfPassword.addActionListener(okAction);
        bCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                FileLog.debug("cancel pressed");
                clearPassword();
                handleCancel();
            }
        });

        KeyListener kl = new KeyListener() {
            public void keyTyped(KeyEvent evt) {
            }

            public void keyPressed(KeyEvent evt) {
                if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
                    FileLog.debug("cancel pressed");
                    clearPassword();
                    handleCancel();
                }
            }

            public void keyReleased(KeyEvent evt) {
            }

        };

        bOk.addKeyListener(kl);
        bCancel.addKeyListener(kl);
        chCertList.addKeyListener(kl);
        tfPassword.addKeyListener(kl);

        // Add data
        refreshCertificates(null);
    }


    public void enableDialog(boolean enable) {
        if (!classicStyle() && userMessageLabel != null) {
            if (enable) {
                clearUserMessage(false);
            } else {
                userMessage("", ResourceManager.getString("PLEASE_WAIT"), false);
            }
        }
        tfPassword.setEnabled(enable);
        bOk.setEnabled(enable);
    }

    private void addCertificateProperties(Properties p, AbstractCertificateHandler currentCertificate) {
        Properties extraProps = currentCertificate.getExtraCertificateProperties();
        if (extraProps != null) {
            for (Enumeration e = extraProps.keys(); e.hasMoreElements();) {
                Object key = e.nextElement();
                p.put(key, extraProps.get(key));
            }
        }
    }
}