/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: AbstractAttachmentViewer.java,v 1.4 2006/08/12 19:02:36 cara Exp $ */

package org.openoces.opensign.client.applet.attach;

/**
 * This class implements generic viewing functionality
 *
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.awt.*;
import java.awt.image.ImageObserver;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;

public abstract class AbstractAttachmentViewer implements AttachmentViewer {
    protected RestrictedAction ra;
    protected Dialog dialog;
    AbstractAttachmentViewer(RestrictedAction ra) {
        this.ra = ra;
    }
    private void closeWindow(){
        if (dialog != null){
            dialog.setVisible(false);
        }
    }
    public void view(Frame parent, String title, byte [] data) {
        dialog = ra.createModalDialog(parent, title);
        dialog.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                closeWindow();
            }
        });
        FileLog.debug("AbstractAttachmentViewer calling getAttachmentComponent() "+this);
        Component c = getAttachmentComponent(data);
        FileLog.debug("got component: "+c+" adding it:");
        dialog.add(c);
        FileLog.debug("added allright");
// buggy?        dialog.add(getAttachmentComponent(data));
        dialog.pack();
        // check if it is too big
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        dialog.setLocation((d.width - dialog.getSize().width) / 2, (d.height - dialog.getSize().height) / 2);
        dialog.setVisible(true);
    }
    abstract Component getAttachmentComponent(byte [] data);
    public static boolean isSupported(){ return true;}
}
