/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: AttachmentViewerManager.java,v 1.4 2006/08/12 19:02:36 cara Exp $ */

package org.openoces.opensign.client.applet.attach;

/**
 * This class manages attachment viewers  
 *
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.OS;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.util.Hashtable;

public class AttachmentViewerManager {
    private static Hashtable viewerRegister = new Hashtable();
    // todo: consider registering class names and instantiate lazily.
    public static void registerViewer(String mimeType, AttachmentViewer viewer){
        viewerRegister.put(mimeType, viewer);
    }
    public static boolean hasViewer(String mimeType){
        return (getViewer(mimeType) != null);
    }
    public static AttachmentViewer getViewer(String mimeType){
        return (AttachmentViewer)viewerRegister.get(mimeType);
    }
    // we just register some viewers here to get going
    public static void registerViewers(RestrictedAction ra){
        if (PlainTextViewer.isSupported()){
            AttachmentViewerManager.registerViewer("text/plain", new PlainTextViewer(ra));
        } else {
            FileLog.debug("no support for PlainTextViewer");
        }
        if (GifViewer.isSupported()){
            AttachmentViewerManager.registerViewer("image/gif", new GifViewer(ra));
        } else {
            FileLog.debug("no support for GifViewer");
        }
        if (HtmlViewer.isSupported()){
            AttachmentViewerManager.registerViewer("text/html", new HtmlViewer(ra));
        } else {
            FileLog.debug("no support for HtmlViewer");
        }
        if (RtfViewer.isSupported()){
            AttachmentViewerManager.registerViewer("text/rtf", new RtfViewer(ra));
        } else {
            FileLog.debug("no support for RtfViewer");
        }
//        AttachmentViewerManager.registerViewer("application/pdf", new PdfViewer(ra));
    }
}
