/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: GifViewer.java,v 1.4 2006/08/12 19:02:36 cara Exp $ */

package org.openoces.opensign.client.applet.attach;

/**
 * This class implements a gif attachment viewer
 *
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.OS;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.awt.*;

public class GifViewer extends AbstractAttachmentViewer {
    public GifViewer(RestrictedAction ra) {
        super(ra);
    }
    Component getAttachmentComponent(byte [] data) {
        Component comp =  new ImageCanvas(data);
        ScrollPane scrollPane = new ScrollPanePlusPrefSize(); 
        scrollPane.add(comp);
        return scrollPane;
    }
    static class ImageCanvas extends Canvas {
        private Image image;
        ImageCanvas(byte [] data){
            image = Toolkit.getDefaultToolkit().createImage(data);
            init(image);
        }
        private void init(Image image){
            MediaTracker mt = new MediaTracker(this);
            // add the image to group #0
            mt.addImage(image, 0);
            try {
                // wait for all of the images to load
                mt.waitForAll();
            }
            catch (InterruptedException ie) {
                ;
            }
        }

        public void paint(Graphics graphics) {
            if (image != null){
                graphics.drawImage(image, 0, 0, null);
            }
        }
        public Dimension getPreferredSize(){
            // check if image downloaded/created?
            Dimension d = new Dimension(image.getWidth(null), image.getHeight(null));
            return d;
        }
    }
}
