/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: PlainTextViewer.java,v 1.4 2006/08/12 19:02:36 cara Exp $ */

package org.openoces.opensign.client.applet.attach;

/**
 * This class implements a plain-text attachment viewer
 *
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.OS;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.awt.*;
import java.io.UnsupportedEncodingException;

public class PlainTextViewer extends AbstractAttachmentViewer {
    PlainTextViewer(RestrictedAction ra){
        super(ra);
    }

    Component getAttachmentComponent(byte [] data) {
        // make it wrapping:
        TextAreaPlusPrefSize ta = new TextAreaPlusPrefSize();
        try {
            // todo: find out what happens here
            String content = new String(data, "UTF8");
            if (content.charAt(0) == 0xFEFF){
                FileLog.debug("skipping BOM");
                content = content.substring(1);
            }
            FileLog.debug("Content: "+content);
            ta.setText(content);
        } catch (UnsupportedEncodingException e){
            FileLog.warn("UTF8 not supported");
            ta.setText("UTF8 not supported");
        }
//        ta.setForeground(Color.RED);
//        ta.setBackground(Color.WHITE);
//        ta.setEnabled(false);
        ta.setPreferredSize(new Dimension(600, 400));//todo: is this sensible?
        ta.setEditable(false);
        return ta;
    }

}
