/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: DelegationAppletStub.java,v 1.3 2006/04/17 19:35:43 cara Exp $ */

package org.openoces.opensign.client.applet.bootstrap;

/**
 * This class implements a delegation stub
 *
 * @author Preben Valeur  <prv@tdc.dk>
 */

import java.applet.AppletStub;
import java.applet.AppletContext;
import java.applet.Applet;
import java.net.URL;

public class DelegationAppletStub implements AppletStub {
    private Applet delegate;
    public DelegationAppletStub(Applet delegate){
        this.delegate = delegate;
    }
    public boolean isActive() {
        return delegate.isActive();
    }

    public void appletResize(int width, int height) {
        delegate.resize(width, height);
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public AppletContext getAppletContext() {
        return delegate.getAppletContext();  //To change body of implemented methods use File | Settings | File Templates.
    }

    public URL getCodeBase() {
        return delegate.getCodeBase();
    }

    public URL getDocumentBase() {
        return delegate.getCodeBase();
    }

    public String getParameter(String name) {
        return delegate.getParameter(name);
    }
}
