/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: OS.java,v 1.3 2006/04/17 19:35:43 cara Exp $ */

package org.openoces.opensign.client.applet.bootstrap;

/**
 * This class defines OS specific functionality.
 *
 * @author Preben Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;

import java.applet.Applet;

public class OS {
    // os.name, java.version, java.vendor
    public static String getBrowser(Applet applet){
//        String theBrowser = "APPLICATION";
        // we know it is not - so:
        String appletContext = applet.getAppletContext().toString();
        String theBrowser = appletContext;
        if (appletContext.startsWith("sun.applet.AppletViewer"))
           theBrowser = "APPLETVIEWER";
        else if (appletContext.startsWith("netscape.applet."))
           theBrowser = "NETSCAPE";
        else if (appletContext.startsWith("com.ms.applet."))
           theBrowser = "MICROSOFT";
        else if (appletContext.startsWith("sunw.hotjava.tags.TagAppletPanel"))
           theBrowser = "HOTJAVA";
        else if (appletContext.startsWith( "sun.plugin.navig.win32.AppletPlugin"))
           theBrowser = "NETSCAPEPLUGIN";
        else if (appletContext.startsWith( "sun.plugin.ocx.ActiveXApplet"))
           theBrowser = "MICROSOFTPLUGIN";
        else if (appletContext.startsWith( "sun.plugin.viewer.context.IExplorerAppletContext"))
           theBrowser = "MICROSOFTPLUGINJRE1.4";
        else if (appletContext.startsWith( "com.opera.PluginContext"))
            theBrowser = "OPERA";
        return theBrowser;
    }

    public static boolean isOSWindows() {
        return (System.getProperty("os.name").toLowerCase().startsWith("win"));
    }

    public static boolean isJavaPlugin(){
        return (System.getProperty("javaplugin.version") != null);
    }

    public static String getJavaPluginVersion(){
        return (System.getProperty("javaplugin.version"));
    }

    public static boolean isMsJVM(){
        return (System.getProperty("java.vendor").indexOf("Microsoft") == 0);
    }

    public static String getRestrictedProperty(final String key, RestrictedAction ra) {
        return ra.getProperty(key);
    }
    // ms version (build)
    // NOTE:The [above] snippet will return the Microsoft VM version.
    // This not the same thing as as the JDK version.
    // In this case , Microsoft's Java environment only goes up to 1.1.4
    // and there is no plan to upgrade it.
//    public static getMsBuild(){
//        String build;
//          build=com.ms.util.SystemVersionManager.getVMVersion().getProperty("BuildIncrement");
//          System.out.println("Microsoft JVM installed is " + build);
//    }
/*
    java.version       Java version number
    java.vendor        Java vendor-specific string
    java.vendor.url    Java vendor URL
    os.name            Operating system name
    os.arch            Operating system architecture
    file.separator     File separator (eg, "/")
    path.separator     Path separator (eg, ":")
    line.separator     Line separator
    java.class.version Java class version number

    But applets are prevented from reading these system properties (for security reason):
    java.home          Java installation directory
    java.class.path    Java classpath
    user.name          User account name
    user.home          User home directory
    user.dir           User's current working directory

    To read a system property from within an applet, simply invoke System.getProperty(key)
    on the property you are interested in. String s = System.getProperty("java.vendor");
*/


}
