/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: OpenSignDownloads.java,v 1.8 2006/06/22 11:38:28 cara Exp $ */

package org.openoces.opensign.client.applet.bootstrap.downloads;

import org.openoces.opensign.client.applet.bootstrap.DownloadItem;
import org.openoces.opensign.client.applet.bootstrap.classloader.Sha1Checksum;

import java.io.File;
import java.util.Vector;

/**
 * This class generates the java class generates the list of plugins available for download
 * 
 * @author Preben Valeur  <prv@tdc.dk>
 */
public class OpenSignDownloads {
    public static Vector getDownloadItems() {
        Vector downloadItems = new Vector();
        DownloadItem item = null;
        downloadItems.addElement(new DownloadItem("OpenSign", "opensign", "org.openoces.opensign.client.applet.Sign", "OpenSign applet", new Sha1Checksum(DownloadChecksums.getopensignChecksum()), DownloadChecksums.getopensignDataSize()));
        downloadItems.addElement(new DownloadItem("OpenLogon", "opensign", "org.openoces.opensign.client.applet.Logon", "OpenLogon applet", new Sha1Checksum(DownloadChecksums.getopensignChecksum()), DownloadChecksums.getopensignDataSize()));
        downloadItems.addElement(new DownloadItem("OpenService", "opensign", "org.openoces.opensign.client.applet.PassApplet", "OpenService applet", new Sha1Checksum(DownloadChecksums.getopensignChecksum()), DownloadChecksums.getopensignDataSize()));
        downloadItems.addElement(new DownloadItem("OpenMail", "opensign", "org.openoces.opensign.client.applet.Pkcs7Applet", "OpenMail applet", new Sha1Checksum(DownloadChecksums.getopensignChecksum()), DownloadChecksums.getopensignDataSize()));
        downloadItems.addElement(new DownloadItem("capi", "org.openoces.opensign.certificate.plugin.capi.CapiKeyStoreHandler", "CAPI support", new Sha1Checksum(DownloadChecksums.getcapiChecksum()), DownloadChecksums.getcapiDataSize(), "MicrosoftCryptoApi"));
        // the next ones requires OS support:
        item = new DownloadItem("cdcard", "org.openoces.opensign.certificate.plugin.cdcard.CdCardKeyStoreHandler", "CDCard keystore support", new Sha1Checksum(DownloadChecksums.getcdcardChecksum()), DownloadChecksums.getcdcardDataSize());
        item.setRequiresOSSupport(true);
        downloadItems.addElement(item);
        item = new DownloadItem("pkcs12", "org.openoces.opensign.certificate.plugin.pkcs12.Pkcs12KeyStoreHandler", "PKCS12 support", new Sha1Checksum(DownloadChecksums.getpkcs12Checksum()), DownloadChecksums.getpkcs12DataSize());
        item.setRequiresOSSupport(true);
        downloadItems.addElement(item);
        item = new DownloadItem("oces", "org.openoces.opensign.certificate.plugin.oces.OcesKeyStoreHandler", "OCES support", new Sha1Checksum(DownloadChecksums.getocesChecksum()), DownloadChecksums.getocesDataSize());
        item.setRequiresOSSupport(true);
        downloadItems.addElement(item);
        // the OS support libs:
        downloadItems.addElement(new DownloadItem("jsse", "org.openoces.opensign.certificate.support.suncrypto.SunCryptoSupport", "SUN crypto support", new Sha1Checksum(DownloadChecksums.getjsseChecksum()), DownloadChecksums.getjsseDataSize()));
        downloadItems.addElement(new DownloadItem("bcjce", "org.openoces.opensign.certificate.support.mscrypto.MsCryptoSupport", "MS JCE crypto support", new Sha1Checksum(DownloadChecksums.getbcjceChecksum()), DownloadChecksums.getbcjceDataSize(), new File("C:\\tmp\\bcjce")));
        // applet specific support
        // see if it works like this for now:
        downloadItems.addElement(new DownloadItem("mailsupport", "org.openoces.opensign.appletsupport.mail.SmimeUtil", "Mail support", new Sha1Checksum(DownloadChecksums.getmailsupportChecksum()), DownloadChecksums.getmailsupportDataSize()));
        downloadItems.addElement(new DownloadItem("attachment", "org.openoces.opensign.client.applet.attach.AttachmentSupportImpl", "Attachment support", new Sha1Checksum(DownloadChecksums.getattachmentChecksum()), DownloadChecksums.getattachmentDataSize()));
        return downloadItems;
    }
}
