/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: RestrictedAction.java,v 1.8 2006/10/21 22:05:47 cara Exp $ */

package org.openoces.opensign.client.applet.bootstrap.interfaces;

import java.awt.*;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URLConnection;
import java.util.Properties;

/**
 * This interface defines restricted actions that requires special the code to be signed
 *
 * @author Preben Valeur  <prv@tdc.dk>
 */

public interface RestrictedAction {
    // special one: set in boot and gotten in bootable
    public String getBaseUrl();

    public void setBaseUrl(String url);
    
    public String getUserHome();

    public String getProperty(String property);

    public FileInputStream getFileInputStream(String fileName);

    public FileInputStream getFileInputStream(File file);

    public FileOutputStream getFileOutputStream(String fileName);

    public FileOutputStream getFileOutputStream(File file);

    // used by filelog...
    public FileOutputStream getFileOutputStream(String fileName, boolean append);

    public InputStream getInputStream(URLConnection con);

    public InputStream getResourceAsStream(Class clazz, String name);

    public boolean mkdirs(File f);

    public boolean delete(File f);

    public boolean exists(File f);

    public boolean isDirectory(File f);

    public String[] list(File dir, FilenameFilter filter);

    public boolean load(String lib);

    public boolean loadLibrary(String lib);

    public Dialog createModalDialog(Frame parent, String title);

    public FileDialog getFileDialog(Frame parent, String title, int mode);

    public void showFileDialog(FileDialog dialog);

    public PrintJob getPrintJob(Frame frame, String title, Properties prefs);

    public Thread createThread(Runnable runnable);

    public void connect(URLConnection con) throws IOException;
    public int getResponseCode(final HttpURLConnection con) throws IOException;

    public void setProperty(String name, String value);

    public OutputStream getOutputStream(URLConnection con);

    public void addSSLProvider() throws IOException;

    public void setDefaultSSLSocketFactory(Object sslSocketFactory);
}
