/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: AbstractDialog.java,v 1.6 2006/08/12 19:02:37 cara Exp $ */

package org.openoces.opensign.client.applet.dialogs;

/**
 * This class represents a common dialog superclass
 *
 * @author Preben Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.OcesAppletUtils;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.awt.*;
import java.util.Vector;

public class AbstractDialog {
    protected Dialog dialog;

    public AbstractDialog(RestrictedAction ra, Frame owner, String title) {
        this.dialog = ra.createModalDialog(owner, title);
    }

    protected void okClicked() {
        dialog.setVisible(false);
    }

    public void centerScreen() {
        Dimension dim = dialog.getToolkit().getScreenSize();
        Rectangle abounds = dialog.getBounds();
        dialog.setLocation((dim.width - abounds.width) / 2,
                (dim.height - abounds.height) / 2);
        dialog.setVisible(true);
        dialog.requestFocus();
    }


// centers the dialog within the parent container [1.1]
//  (put that in the Dialog class)
    public void centerParent() {
        int x;
        int y;

        // Find out our parent
        Container myParent = dialog.getParent();
        Point topLeft = myParent.getLocationOnScreen();
        Dimension parentSize = myParent.getSize();

        Dimension mySize = dialog.getSize();

        if (parentSize.width > mySize.width)
            x = ((parentSize.width - mySize.width) / 2) + topLeft.x;
        else
            x = topLeft.x;

        if (parentSize.height > mySize.height)
            y = ((parentSize.height - mySize.height) / 2) + topLeft.y;
        else
            y = topLeft.y;

        dialog.setLocation(x, y);
        dialog.setVisible(true);
        dialog.requestFocus();
    }

    public void show() {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        dialog.setLocation((d.width - dialog.getPreferredSize().width) / 2, (d.height - dialog.getPreferredSize().height) / 2);
        dialog.setVisible(true);
    }
}
