/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: DlgAbout.java,v 1.7 2006/06/15 13:09:04 cara Exp $ */

package org.openoces.opensign.client.applet.dialogs;

/**
 * This class represent the about dialog box
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 * @author Carsten Raskgaard  <carsten@raskgaard.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.resources.ResourceManager;
import org.openoces.opensign.utils.Version;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class DlgAbout extends AbstractDialog {
    public DlgAbout(RestrictedAction ra, Frame owner) throws Exception {
        super(ra, owner, "");

        java.awt.Label[] lLines;
        lLines = new Label[10];

		Button bOk;
        TextArea taLicense;

		dialog.setLayout(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.fill = GridBagConstraints.NONE;
		c.weightx = 0;
		c.weighty = 0;
		c.anchor = GridBagConstraints.CENTER;
		c.insets = new Insets(3, 3, 3, 3);

		bOk = new Button(ResourceManager.getString("DLG_INFO_BUTTON_OK"));

        taLicense = new TextArea();
        taLicense.setEditable(false);
        taLicense.setRows(8);
        taLicense.setColumns(40);
        taLicense.setText(ResourceManager.getString("DLG_ABOUT_LGPL_NOTICE"));

        for (int i = 0; i < lLines.length; i++) {
            lLines[i] = new Label();
        }

        int i=0;
        lLines[i].setAlignment(Label.CENTER);
        lLines[i++].setText(ResourceManager.getString("DLG_ABOUT_NAME"));
        lLines[i++].setText(ResourceManager.getString("DLG_ABOUT_NAME_DETAILS"));
        lLines[i++].setText(Version.oneliner());
        lLines[i++].setText("Project homepage: http://www.openoces.org");
        lLines[i++].setText(ResourceManager.getString("DLG_ABOUT_MAJOR_CONTRIBUTORS"));
        lLines[i++].setText("(c) 2002-2006, IT Practice A/S");
        lLines[i++].setText("http://it-practice.dk");
        lLines[i++].setText("http://www.portalprotect.dk");
        lLines[i++].setText("(c) 2003-2006 TDC A/S");
        lLines[i++].setText("http://tdc.dk");

		bOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okClicked();
			}
		});

        for (int j = 0; j < lLines.length; j++) {
            dialog.add(lLines[j],c);
            c.anchor = GridBagConstraints.WEST;
            c.gridy++;
        }

        c.anchor = GridBagConstraints.CENTER;
        dialog.add(taLicense,c);
		c.gridy++;
		dialog.add(bOk, c);

		dialog.pack();
	}
}
