/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: DlgConditions.java,v 1.4 2006/04/02 20:30:53 cara Exp $ */

package org.openoces.opensign.client.applet.dialogs;

/**
 * This class represent a dialog displaying conditions
 *
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.resources.ResourceManager;
import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class DlgConditions extends AbstractDialog {
    boolean cancelled;

    public boolean isCancelled() {
        return cancelled;
    }
    private String conditions;
    public DlgConditions(RestrictedAction ra, Frame owner, String title, String conditions, int rows, int cols) {
        super(ra, owner, title);
        this.conditions = conditions;

        dialog.setLayout(new BorderLayout());

        TextArea ta = new TextArea(conditions, rows, cols, TextArea.SCROLLBARS_VERTICAL_ONLY);
        ta.setEditable(false);
        dialog.add(ta, BorderLayout.CENTER);

        Button bCancel = new Button(ResourceManager.getString("DLG_PASSWORD_BUTTON_CANCEL"));
        Button bOk = new Button(ResourceManager.getString("DLG_PASSWORD_BUTTON_OK"));
        Panel pnlButtons = new Panel();
        pnlButtons.add(bOk);
        pnlButtons.add(bCancel);
        dialog.add(pnlButtons, BorderLayout.SOUTH);

        bCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelClicked();
            }
        });
        bOk.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                okClicked();
            }
        });
        dialog.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                cancelClicked();
            }

        });
        dialog.pack();
    }
    protected void okClicked() {
        cancelled = false;
        dialog.hide();
    }

    private void cancelClicked() {
        cancelled = true;
        dialog.hide();
    }
}
