/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: DlgConfirm.java,v 1.3 2006/08/12 19:02:37 cara Exp $ */

package org.openoces.opensign.client.applet.dialogs;

/**
 * This class represent a confirmation dialog
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;
import org.openoces.opensign.client.applet.resources.ResourceManager;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

import java.awt.*;
import java.awt.event.*;

public class DlgConfirm extends AbstractDialog {

    Panel pnl;
    Label lblMessage;

    protected Button bCancel;
    protected Button bOk;
    protected Label msgLabel;
    Panel pnlButtons;
    protected boolean cancelled;

    public boolean isCancelled() {
        return cancelled;
    }

    public DlgConfirm(RestrictedAction ra, Frame owner, String title, String confirmationMsg) {
        super(ra, owner, title);
        dialog.setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.fill = GridBagConstraints.NONE;
        c.weightx = 0;
        c.weighty = 0;
        c.anchor = GridBagConstraints.WEST;
        c.insets = new Insets(3, 3, 3, 3);

        msgLabel = new Label(confirmationMsg);
        c.gridx = 0;
        c.gridy++;
        c.gridwidth = 3;
        dialog.add(msgLabel, c);

        bCancel = new Button(ResourceManager.getString("DLG_PASSWORD_BUTTON_CANCEL"));
        bOk = new Button(ResourceManager.getString("DLG_PASSWORD_BUTTON_OK"));

        pnlButtons = new Panel();
        pnlButtons.add(bOk);
        pnlButtons.add(bCancel);

        c.gridx = 0;
        c.gridy++;
        c.gridwidth = 3;

        c.anchor = GridBagConstraints.WEST;

        dialog.add(pnlButtons, c);

        bCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelClicked();
            }
        });
        bOk.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                okClicked();
            }
        });

        KeyListener kl = new KeyListener() {
            public void keyTyped(KeyEvent evt) {
            }

            public void keyPressed(KeyEvent evt) {
                if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
                    cancelClicked();
                }
                if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
                    okClicked();
                }
            }

            public void keyReleased(KeyEvent evt) {
            }
        };

        bCancel.addKeyListener(kl);
        bOk.addKeyListener(kl);

        dialog.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                cancelClicked();
            }

        });
        dialog.pack();
    }

    protected void okClicked() {
        cancelled = false;
        dialog.hide();
    }

    private void cancelClicked() {
        cancelled = true;
        dialog.hide();
    }
}
