/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: DlgInformation.java,v 1.3 2006/04/02 20:30:53 cara Exp $ */

package org.openoces.opensign.client.applet.dialogs;

/**
 * This class represent a general dialog box displaying information
 *
 * @author Carsten Raskgaard  <carsten@raskgaard.dk>
 * @author Preben Rosendal Valeur  <prv@tdc.dk>
 */

import org.openoces.opensign.client.applet.bootstrap.interfaces.RestrictedAction;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class DlgInformation extends AbstractDialog {
     public DlgInformation(RestrictedAction ra, Frame owner, String title, String text, String ok) {
         super(ra, owner, title);

         Label lInformation;
         Button bOk;

         dialog.setLayout(new GridBagLayout());

         GridBagConstraints c = new GridBagConstraints();
         c.gridx = 0;
         c.gridy = 0;
         c.gridwidth = 1;
         c.gridheight = 1;
         c.fill = GridBagConstraints.NONE;
         c.weightx = 0;
         c.weighty = 0;
         c.anchor = GridBagConstraints.CENTER;
         c.insets = new Insets(3, 3, 3, 3);

         lInformation = new Label(text);

         bOk = new Button(ok);

         bOk.addActionListener(new ActionListener() {
             public void actionPerformed(ActionEvent e) {
                 okClicked();
             }
         });

         dialog.add(lInformation, c);
         c.gridy++;
         dialog.add(bOk, c);

         dialog.pack();
     }

     public void show(){
//        centerScreen();
        centerParent();
//        dialog.show();
     }
// centers the dialog within the screen [1.1]
//  (put that in the Frame/Dialog class)
}
