/*
    Copyright 2006 IT Practice A/S
    Copyright 2006 TDC Totalløsninger A/S
    Copyright 2006 Jens Bo Friis
    Copyright 2006 Preben Rosendal Valeur
    Copyright 2006 Carsten Raskgaard


    This file is part of OpenSign.

    OpenSign is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    OpenSign is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with OpenOcesAPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    Note to developers:
    If you add code to this file, please take a minute to add an additional
    copyright statement above and an additional
    @author statement below.
*/

/* $Id: Version.java,v 1.23 2006/10/22 09:34:22 cara Exp $ */

package org.openoces.opensign.utils;

import java.io.InputStream;
import java.util.Properties;
import org.openoces.opensign.client.applet.bootstrap.FileLog;

/**
 * This class implements versioning info.
 *
 * @author Jens Bo Friis  <jbf@it-practice.dk>
 */

public class Version {
    private static Properties props;

    private synchronized static void readVersion() {
//		if (!OS.javaplugin) {
//			try {
//				netscape.security.PrivilegeManager.enablePrivilege("UniversalPropertyRead");
//				netscape.security.PrivilegeManager.enablePrivilege("UniversalTopLevelWindow");
//			} catch (Throwable t) {
//			}
//			try {
//				com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.SYSTEM);
//			} catch (Throwable t) {
//			};
//		}
        FileLog.info("in Version.ReadVersion()");
        InputStream is = null;
        props = new Properties();
// todo: set back again - prv
        props.put("version.major", "1");
        props.put("version.minor", "5");
        props.put("version.minest", "2");
        props.put("version.branch", "");
        props.put("copyright", "(c) 2002-2004, IT Practice A/S");
        props.put("version.release", "121");
        props.put("build.version", "OpenSign by IT Practice A/S");
        props.put("build.timestamp", "2006/01/30 15:00");
//        if (true) return;
//        // todo: maybe put it back in as it was - something like below
//		try {
//			is = OS.getRestrictedAction().getResourceAsStream(Version.class, "/opensign.version");
////			is = Version.class.getResourceAsStream("/opensign.version");
//			if (is == null)
//				is = new FileInputStream("opensign.version");
//			if (is == null)
//				is = new FileInputStream("../opensign.version");
//			if (is != null)
//				props.load(is);
//			if (FileLog.isDebugEnabled)
//				FileLog.debug("OPENSIGN VERSION ATTRIBUTES:" + props.toString());
//		} catch (IOException e) {
//			System.err.println("FATAL ERROR! Could not read version information");
//		} finally {
//			try {
//				if (is != null) {
//					is.close();
//				}
//			} catch (Exception e) {
//			}
//		}
    }

    public static String getBuildTimeStamp() {
        if (props == null)
            readVersion();
        return props.getProperty("build.timestamp", "na");
    }

    public static String getVersion() {
        if (props == null)
            readVersion();
        String s = props.getProperty("version.major", "na") + "." + props.getProperty("version.minor", "na") + "." + props.getProperty("version.minest", "na");
        if ( props.getProperty("version.branch") != null && !props.getProperty("version.branch").equals("") ) {
            s += "-" + props.getProperty("version.branch", "n/a");
        }
        return s;
    }

    public static String getCopyright() {
        if (props == null)
            readVersion();
        return props.getProperty("copyright", "(c) 2003, IT Practice A/S");
    }

    public static String oneliner() {
        return "v" + getVersion();
    }

    public static String getBuildVersion() {
        if (props == null)
            readVersion();
        return props.getProperty("build.version", "na");
    }

    public static void main(String[] args) {
        System.out.println(Version.oneliner());
    }
}